Index: /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1459)
+++ /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1460)
@@ -63,5 +63,6 @@
 TAppDecTop::TAppDecTop()
 #if Q0074_COLOUR_REMAPPING_SEI
-: seiColourRemappingInfoPrevious(NULL)
+: m_pcSeiColourRemappingInfoPrevious(NULL)
+, m_pcPicYuvColourRemapped(NULL)
 #endif
 {
@@ -78,5 +79,6 @@
 : m_iPOCLastDisplay(-MAX_INT)
 #if Q0074_COLOUR_REMAPPING_SEI
-, seiColourRemappingInfoPrevious(NULL)
+ ,m_pcSeiColourRemappingInfoPrevious(NULL)
+ ,m_pcPicYuvColourRemapped(NULL)
 #endif
 {
@@ -117,10 +119,4 @@
 #else
   m_reconFileName.clear();
-#endif
-#if Q0074_COLOUR_REMAPPING_SEI
-  if (seiColourRemappingInfoPrevious != NULL)
-  {
-    delete seiColourRemappingInfoPrevious;
-  }
 #endif
 }
@@ -688,4 +684,17 @@
   }
 #endif
+#if Q0074_COLOUR_REMAPPING_SEI
+  if (m_pcSeiColourRemappingInfoPrevious != NULL)
+  {
+    delete m_pcSeiColourRemappingInfoPrevious;
+    m_pcSeiColourRemappingInfoPrevious = NULL;
+  }
+  if (m_pcPicYuvColourRemapped != NULL)
+  {
+    m_pcPicYuvColourRemapped->destroy();
+    delete m_pcPicYuvColourRemapped;
+    m_pcPicYuvColourRemapped  = NULL;
+  }
+#endif
 }
 
@@ -919,38 +928,7 @@
 
 #if Q0074_COLOUR_REMAPPING_SEI
-        if (m_colourRemapSEIEnabled)
-        {
-          SEIMessages colourRemappingInfo = getSeisByType(pcPic->getSEIs(), SEI::COLOUR_REMAPPING_INFO );
-          const SEIColourRemappingInfo *seiColourRemappingInfo = ( colourRemappingInfo.size() > 0 ) ? (SEIColourRemappingInfo*) *(colourRemappingInfo.begin()) : NULL;
-          const TComSPS *sps = pcPic->getSlice(0)->getSPS();
-
-          if (colourRemappingInfo.size() > 1)
-          {
-            printf ("Warning: Got multiple Colour Remapping Information SEI messages. Using first.");
-          }
-          if (seiColourRemappingInfo)
-          {
-            xApplyColourRemapping(sps, *pcPic->getPicYuvRec(), seiColourRemappingInfo);
-          }
-          else  // using the last CRI SEI received
-          {
-            const SEIColourRemappingInfo *seiColourRemappingInfoCopy;
-            seiColourRemappingInfoCopy = seiColourRemappingInfoPrevious;
-            xApplyColourRemapping(sps, *pcPic->getPicYuvRec(), seiColourRemappingInfoCopy);
-          }
-
-          // save the last CRI SEI received
-          if( seiColourRemappingInfo != NULL){
-            if (seiColourRemappingInfoPrevious != NULL)
-            {
-              delete seiColourRemappingInfoPrevious;
-              seiColourRemappingInfoPrevious = NULL;
-            }
-            if (seiColourRemappingInfo->m_colourRemapPersistenceFlag)
-            {
-              seiColourRemappingInfoPrevious = new SEIColourRemappingInfo();
-              seiColourRemappingInfoPrevious->copyFrom(seiColourRemappingInfo);
-            }
-          }
+        if (!m_colourRemapSEIFileName.empty())
+        {
+          xOutputColourRemapPic(pcPic, activeSPS);
         }
 #endif
@@ -1122,38 +1100,7 @@
 
 #if Q0074_COLOUR_REMAPPING_SEI
-        if (m_colourRemapSEIEnabled)
-        {
-          SEIMessages colourRemappingInfo = getSeisByType(pcPic->getSEIs(), SEI::COLOUR_REMAPPING_INFO );
-          const SEIColourRemappingInfo *seiColourRemappingInfo = ( colourRemappingInfo.size() > 0 ) ? (SEIColourRemappingInfo*) *(colourRemappingInfo.begin()) : NULL;
-          const TComSPS *sps = pcPic->getSlice(0)->getSPS();
-
-          if (colourRemappingInfo.size() > 1)
-          {
-            printf ("Warning: Got multiple Colour Remapping Information SEI messages. Using first.");
-          }
-          if (seiColourRemappingInfo)
-          {
-            xApplyColourRemapping( sps, *pcPic->getPicYuvRec(), seiColourRemappingInfo );
-          }
-          else  // using the last CRI SEI received
-          {
-            const SEIColourRemappingInfo *seiColourRemappingInfoCopy;
-            seiColourRemappingInfoCopy = seiColourRemappingInfoPrevious;
-            xApplyColourRemapping( sps, *pcPic->getPicYuvRec(), seiColourRemappingInfoCopy );
-          }
-
-          // save the last CRI SEI received
-          if( seiColourRemappingInfo != NULL){
-            if (seiColourRemappingInfoPrevious != NULL)
-            {
-              delete seiColourRemappingInfoPrevious;
-              seiColourRemappingInfoPrevious = NULL;
-            }
-            if (seiColourRemappingInfo->m_colourRemapPersistenceFlag)
-            {
-              seiColourRemappingInfoPrevious = new SEIColourRemappingInfo();
-              seiColourRemappingInfoPrevious->copyFrom(seiColourRemappingInfo);
-            }
-          }
+        if (!m_colourRemapSEIFileName.empty())
+        {
+          xOutputColourRemapPic(pcPic, &(pcPic->getPicSym()->getSPS()));
         }
 #endif
@@ -1215,4 +1162,339 @@
   return false;
 }
+
+#if Q0074_COLOUR_REMAPPING_SEI
+
+Void TAppDecTop::xOutputColourRemapPic(TComPic* pcPic, const TComSPS* activeSPS)
+{
+  SEIMessages colourRemappingInfo = getSeisByType(pcPic->getSEIs(), SEI::COLOUR_REMAPPING_INFO );
+  SEIColourRemappingInfo *seiColourRemappingInfo = ( colourRemappingInfo.size() > 0 ) ? (SEIColourRemappingInfo*) *(colourRemappingInfo.begin()) : NULL;
+
+  if (colourRemappingInfo.size() > 1)
+  {
+    printf ("Warning: Got multiple Colour Remapping Information SEI messages. Using first.");
+  }
+  if (seiColourRemappingInfo)
+  {
+    applyColourRemapping(*pcPic->getPicYuvRec(), *seiColourRemappingInfo, *activeSPS);
+  }
+  else  // using the last CRI SEI received
+  {
+    if (m_pcSeiColourRemappingInfoPrevious != NULL)
+    {
+      if (m_pcSeiColourRemappingInfoPrevious->m_colourRemapPersistenceFlag == false)
+      {
+        printf("Warning No SEI-CRI message is present for the current picture, persistence of the CRI is not managed\n");
+      }
+      SEIColourRemappingInfo *seiColourRemappingInfoCopy;
+      seiColourRemappingInfoCopy = m_pcSeiColourRemappingInfoPrevious;
+      applyColourRemapping(*pcPic->getPicYuvRec(), *seiColourRemappingInfoCopy, *activeSPS);
+    }
+  }
+
+  // save the last CRI SEI received
+  if( seiColourRemappingInfo != NULL)
+  {
+    if (m_pcSeiColourRemappingInfoPrevious != NULL)
+    {
+      delete m_pcSeiColourRemappingInfoPrevious;
+      m_pcSeiColourRemappingInfoPrevious = NULL;
+    }
+    m_pcSeiColourRemappingInfoPrevious = new SEIColourRemappingInfo();
+    m_pcSeiColourRemappingInfoPrevious->copyFrom(*seiColourRemappingInfo);
+  }
+}
+
+// compute lut from SEI
+// use at lutPoints points aligned on a power of 2 value
+// SEI Lut must be in ascending values of coded Values
+static std::vector<Int>
+initColourRemappingInfoLut(const Int                                          bitDepth_in,     // bit-depth of the input values of the LUT
+                           const Int                                          nbDecimalValues, // Position of the fixed point
+                           const std::vector<SEIColourRemappingInfo::CRIlut> &lut,
+                           const Int                                          maxValue, // maximum output value
+                           const Int                                          lutOffset)
+{
+  const Int lutPoints = (1 << bitDepth_in) + 1 ;
+  std::vector<Int> retLut(lutPoints);
+
+  // missing values: need to define default values before first definition (check codedValue[0] == 0)
+  Int iTargetPrev = (lut.size() && lut[0].codedValue == 0) ? lut[0].targetValue: 0;
+  Int startPivot = (lut.size())? ((lut[0].codedValue == 0)? 1: 0): 1;
+  Int iCodedPrev  = 0;
+  // set max value with the coded bit-depth
+  // + ((1 << nbDecimalValues) - 1) is for the added bits
+  const Int maxValueFixedPoint = (maxValue << nbDecimalValues) + ((1 << nbDecimalValues) - 1);
+
+  Int iValue = 0;
+
+  for ( Int iPivot=startPivot ; iPivot < (Int)lut.size(); iPivot++ )
+  {
+    Int iCodedNext  = lut[iPivot].codedValue;
+    Int iTargetNext = lut[iPivot].targetValue;
+
+    // ensure correct bit depth and avoid overflow in lut address
+    Int iCodedNext_bitDepth = std::min(iCodedNext, (1 << bitDepth_in));
+
+    const Int divValue =  (iCodedNext - iCodedPrev > 0)? (iCodedNext - iCodedPrev): 1;
+    const Int lutValInit = (lutOffset + iTargetPrev) << nbDecimalValues;
+    const Int roundValue = divValue / 2;
+    for ( ; iValue<iCodedNext_bitDepth; iValue++ )
+    {
+      Int value = iValue;
+      Int interpol = ((((value-iCodedPrev) * (iTargetNext - iTargetPrev)) << nbDecimalValues) + roundValue) / divValue;               
+      retLut[iValue]  = std::min(lutValInit + interpol , maxValueFixedPoint);
+    }
+    iCodedPrev  = iCodedNext;
+    iTargetPrev = iTargetNext;
+  }
+  // fill missing values if necessary
+  if(iCodedPrev < (1 << bitDepth_in)+1)
+  {
+    Int iCodedNext  = (1 << bitDepth_in);
+    Int iTargetNext = (1 << bitDepth_in) - 1;
+
+    const Int divValue =  (iCodedNext - iCodedPrev > 0)? (iCodedNext - iCodedPrev): 1;
+    const Int lutValInit = (lutOffset + iTargetPrev) << nbDecimalValues;
+    const Int roundValue = divValue / 2;
+
+    for ( ; iValue<=iCodedNext; iValue++ )
+    {
+      Int value = iValue;
+      Int interpol = ((((value-iCodedPrev) * (iTargetNext - iTargetPrev)) << nbDecimalValues) + roundValue) / divValue; 
+      retLut[iValue]  = std::min(lutValInit + interpol , maxValueFixedPoint);
+    }
+  }
+  return retLut;
+}
+
+static Void
+initColourRemappingInfoLuts(std::vector<Int>      (&preLut)[3],
+                            std::vector<Int>      (&postLut)[3],
+                            SEIColourRemappingInfo &pCriSEI,
+                            const Int               maxBitDepth)
+{
+  Int internalBitDepth = pCriSEI.m_colourRemapBitDepth;
+  for ( Int c=0 ; c<3 ; c++ )
+  {
+    std::sort(pCriSEI.m_preLut[c].begin(), pCriSEI.m_preLut[c].end()); // ensure preLut is ordered in ascending values of codedValues   
+    preLut[c] = initColourRemappingInfoLut(pCriSEI.m_colourRemapInputBitDepth, maxBitDepth - pCriSEI.m_colourRemapInputBitDepth, pCriSEI.m_preLut[c], ((1 << internalBitDepth) - 1), 0); //Fill preLut
+
+    std::sort(pCriSEI.m_postLut[c].begin(), pCriSEI.m_postLut[c].end()); // ensure postLut is ordered in ascending values of codedValues       
+    postLut[c] = initColourRemappingInfoLut(pCriSEI.m_colourRemapBitDepth, maxBitDepth - pCriSEI.m_colourRemapBitDepth, pCriSEI.m_postLut[c], (1 << internalBitDepth) - 1, 0); //Fill postLut
+  }
+}
+
+// apply lut.
+// Input lut values are aligned on power of 2 boundaries
+static Int
+applyColourRemappingInfoLut1D(Int inVal, const std::vector<Int> &lut, const Int inValPrecisionBits)
+{
+  const Int roundValue = (inValPrecisionBits)? 1 << (inValPrecisionBits - 1): 0;
+  inVal = std::min(std::max(0, inVal), (Int)(((lut.size()-1) << inValPrecisionBits)));
+  Int index  = (Int) std::min((inVal >> inValPrecisionBits), (Int)(lut.size()-2));
+  Int outVal = (( inVal - (index<<inValPrecisionBits) ) * (lut[index+1] - lut[index]) + roundValue) >> inValPrecisionBits;
+  outVal +=  lut[index] ;
+
+  return outVal;
+}  
+
+static Int
+applyColourRemappingInfoMatrix(const Int (&colourRemapCoeffs)[3], const Int postOffsetShift, const Int p0, const Int p1, const Int p2, const Int offset)
+{
+  Int YUVMat = (colourRemapCoeffs[0]* p0 + colourRemapCoeffs[1]* p1 + colourRemapCoeffs[2]* p2  + offset) >> postOffsetShift;
+  return YUVMat;
+}
+
+static Void
+setColourRemappingInfoMatrixOffset(Int (&matrixOffset)[3], Int offset0, Int offset1, Int offset2)
+{
+  matrixOffset[0] = offset0;
+  matrixOffset[1] = offset1;
+  matrixOffset[2] = offset2;
+}
+
+static Void
+setColourRemappingInfoMatrixOffsets(      Int  (&matrixInputOffset)[3],
+                                          Int  (&matrixOutputOffset)[3],
+                                    const Int  bitDepth,
+                                    const Bool crInputFullRangeFlag,
+                                    const Int  crInputMatrixCoefficients,
+                                    const Bool crFullRangeFlag,
+                                    const Int  crMatrixCoefficients)
+{
+  // set static matrix offsets
+  Int crInputOffsetLuma = (crInputFullRangeFlag)? 0:-(16 << (bitDepth-8));
+  Int crOffsetLuma = (crFullRangeFlag)? 0:(16 << (bitDepth-8));
+  Int crInputOffsetChroma = 0;
+  Int crOffsetChroma = 0;
+
+  switch(crInputMatrixCoefficients)
+  {
+    case MATRIX_COEFFICIENTS_RGB:
+      crInputOffsetChroma = 0;
+      if(!crInputFullRangeFlag)
+      {
+        fprintf(stderr, "WARNING: crInputMatrixCoefficients set to MATRIX_COEFFICIENTS_RGB and crInputFullRangeFlag not set\n");
+        crInputOffsetLuma = 0;
+      }
+      break;
+    case MATRIX_COEFFICIENTS_UNSPECIFIED:
+    case MATRIX_COEFFICIENTS_BT709:
+    case MATRIX_COEFFICIENTS_BT2020_NON_CONSTANT_LUMINANCE:
+      crInputOffsetChroma = -(1 << (bitDepth-1));
+      break;
+    default:
+      fprintf(stderr, "WARNING: crInputMatrixCoefficients set to undefined value: %d\n", crInputMatrixCoefficients);
+  }
+
+  switch(crMatrixCoefficients)
+  {
+    case MATRIX_COEFFICIENTS_RGB:
+      crOffsetChroma = 0;
+      if(!crFullRangeFlag)
+      {
+        fprintf(stderr, "WARNING: crMatrixCoefficients set to MATRIX_COEFFICIENTS_RGB and crInputFullRangeFlag not set\n");
+        crOffsetLuma = 0;
+      }
+      break;
+    case MATRIX_COEFFICIENTS_UNSPECIFIED:
+    case MATRIX_COEFFICIENTS_BT709:
+    case MATRIX_COEFFICIENTS_BT2020_NON_CONSTANT_LUMINANCE:
+      crOffsetChroma = (1 << (bitDepth-1));
+      break;
+    default:
+      fprintf(stderr, "WARNING: crMatrixCoefficients set to undefined value: %d\n", crMatrixCoefficients);
+  }
+
+  setColourRemappingInfoMatrixOffset(matrixInputOffset, crInputOffsetLuma, crInputOffsetChroma, crInputOffsetChroma);
+  setColourRemappingInfoMatrixOffset(matrixOutputOffset, crOffsetLuma, crOffsetChroma, crOffsetChroma);
+}
+
+Void TAppDecTop::applyColourRemapping(const TComPicYuv& pic, SEIColourRemappingInfo& criSEI, const TComSPS &activeSPS)
+{  
+  const Int maxBitDepth = 16;
+  Bool firstPicture = true;
+
+  // create colour remapped picture
+  if ( m_pcPicYuvColourRemapped == NULL )
+  {
+    const ChromaFormat chromaFormatIDC = activeSPS.getChromaFormatIdc();
+    const Int          iWidth          = activeSPS.getPicWidthInLumaSamples();
+    const Int          iHeight         = activeSPS.getPicHeightInLumaSamples();
+    const UInt         uiMaxCuWidth    = activeSPS.getMaxCUWidth();
+    const UInt         uiMaxCuHeight   = activeSPS.getMaxCUHeight();
+    const UInt         uiMaxDepth      = activeSPS.getMaxTotalCUDepth();
+    m_pcPicYuvColourRemapped  = new TComPicYuv;
+    m_pcPicYuvColourRemapped->create( iWidth, iHeight, chromaFormatIDC, uiMaxCuWidth, uiMaxCuHeight, uiMaxDepth, true );
+  }
+  else
+  {
+    firstPicture = false;
+  }
+
+  if( !criSEI.m_colourRemapCancelFlag )
+  {
+    const Int  iHeight  = pic.getHeight(COMPONENT_Y);
+    const Int  iWidth   = pic.getWidth(COMPONENT_Y);
+    const Int  iStride  = pic.getStride(COMPONENT_Y);
+    const Int  iCStride = pic.getStride(COMPONENT_Cb);
+    const Bool b444     = ( pic.getChromaFormat() == CHROMA_444 );
+    const Bool b422     = ( pic.getChromaFormat() == CHROMA_422 );
+    const Bool b420     = ( pic.getChromaFormat() == CHROMA_420 );
+
+    std::vector<Int> preLut[3];
+    std::vector<Int> postLut[3];
+    Int matrixInputOffset[3];
+    Int matrixOutputOffset[3];
+    const Pel *YUVIn[MAX_NUM_COMPONENT];
+    Pel *YUVOut[MAX_NUM_COMPONENT];
+    YUVIn[COMPONENT_Y]  = pic.getAddr(COMPONENT_Y);
+    YUVIn[COMPONENT_Cb] = pic.getAddr(COMPONENT_Cb);
+    YUVIn[COMPONENT_Cr] = pic.getAddr(COMPONENT_Cr);
+    YUVOut[COMPONENT_Y]  = m_pcPicYuvColourRemapped->getAddr(COMPONENT_Y);
+    YUVOut[COMPONENT_Cb] = m_pcPicYuvColourRemapped->getAddr(COMPONENT_Cb);
+    YUVOut[COMPONENT_Cr] = m_pcPicYuvColourRemapped->getAddr(COMPONENT_Cr);
+
+    Int bitDepthY = activeSPS.getBitDepth(CHANNEL_TYPE_LUMA);
+    assert(bitDepthY == activeSPS.getBitDepth(CHANNEL_TYPE_CHROMA)); // Different bitdepth is not implemented
+
+    const Int postOffsetShift = criSEI.m_log2MatrixDenom;
+    const Int matrixRound = 1 << (postOffsetShift - 1);
+    const Int postLutInputPrecision = (maxBitDepth - criSEI.m_colourRemapBitDepth);
+
+    if ( ! criSEI.m_colourRemapVideoSignalInfoPresentFlag ) // setting default
+    {
+      setColourRemappingInfoMatrixOffsets(matrixInputOffset, matrixOutputOffset, maxBitDepth,
+          activeSPS.getVuiParameters()->getVideoFullRangeFlag(), activeSPS.getVuiParameters()->getMatrixCoefficients(),
+          activeSPS.getVuiParameters()->getVideoFullRangeFlag(), activeSPS.getVuiParameters()->getMatrixCoefficients());
+    }
+    else
+    {
+      setColourRemappingInfoMatrixOffsets(matrixInputOffset, matrixOutputOffset, maxBitDepth,
+          activeSPS.getVuiParameters()->getVideoFullRangeFlag(), activeSPS.getVuiParameters()->getMatrixCoefficients(),
+          criSEI.m_colourRemapFullRangeFlag, criSEI.m_colourRemapMatrixCoefficients);
+    }
+
+    // add matrix rounding to output matrix offsets
+    matrixOutputOffset[0] = (matrixOutputOffset[0] << postOffsetShift) + matrixRound;
+    matrixOutputOffset[1] = (matrixOutputOffset[1] << postOffsetShift) + matrixRound;
+    matrixOutputOffset[2] = (matrixOutputOffset[2] << postOffsetShift) + matrixRound;
+
+    // Merge   matrixInputOffset and matrixOutputOffset to matrixOutputOffset
+    matrixOutputOffset[0] += applyColourRemappingInfoMatrix(criSEI.m_colourRemapCoeffs[0], 0, matrixInputOffset[0], matrixInputOffset[1], matrixInputOffset[2], 0);
+    matrixOutputOffset[1] += applyColourRemappingInfoMatrix(criSEI.m_colourRemapCoeffs[1], 0, matrixInputOffset[0], matrixInputOffset[1], matrixInputOffset[2], 0);
+    matrixOutputOffset[2] += applyColourRemappingInfoMatrix(criSEI.m_colourRemapCoeffs[2], 0, matrixInputOffset[0], matrixInputOffset[1], matrixInputOffset[2], 0);
+
+    // rescaling output: include CRI/output frame difference
+    const Int scaleShiftOut_neg = abs(bitDepthY - maxBitDepth);
+    const Int scaleOut_round = 1 << (scaleShiftOut_neg-1);
+
+    initColourRemappingInfoLuts(preLut, postLut, criSEI, maxBitDepth);
+
+    assert(pic.getChromaFormat() != CHROMA_400);
+    const Int hs = pic.getComponentScaleX(ComponentID(COMPONENT_Cb));
+
+    for( Int y = 0; y < iHeight; y++ )
+    {
+      for( Int x = 0; x < iWidth; x++ )
+      {
+        const Int xc = (x>>hs);
+        Bool computeChroma = b444 || ((b422 || !(y&1)) && !(x&1));
+
+        Int YUVPre_0 = applyColourRemappingInfoLut1D(YUVIn[COMPONENT_Y][x], preLut[0], 0);
+        Int YUVPre_1 = applyColourRemappingInfoLut1D(YUVIn[COMPONENT_Cb][xc], preLut[1], 0);
+        Int YUVPre_2 = applyColourRemappingInfoLut1D(YUVIn[COMPONENT_Cr][xc], preLut[2], 0);
+
+        Int YUVMat_0 = applyColourRemappingInfoMatrix(criSEI.m_colourRemapCoeffs[0], postOffsetShift, YUVPre_0, YUVPre_1, YUVPre_2, matrixOutputOffset[0]);
+        Int YUVLutB_0 = applyColourRemappingInfoLut1D(YUVMat_0, postLut[0], postLutInputPrecision);
+        YUVOut[COMPONENT_Y][x] = (YUVLutB_0 + scaleOut_round) >> scaleShiftOut_neg; // scaling output
+
+        if( computeChroma )
+        {
+          Int YUVMat_1 = applyColourRemappingInfoMatrix(criSEI.m_colourRemapCoeffs[1], postOffsetShift, YUVPre_0, YUVPre_1, YUVPre_2, matrixOutputOffset[1]);
+          Int YUVLutB_1 = applyColourRemappingInfoLut1D(YUVMat_1, postLut[1], postLutInputPrecision);
+          YUVOut[COMPONENT_Cb][xc] = (YUVLutB_1 + scaleOut_round) >> scaleShiftOut_neg; // scaling output
+
+          Int YUVMat_2 = applyColourRemappingInfoMatrix(criSEI.m_colourRemapCoeffs[2], postOffsetShift, YUVPre_0, YUVPre_1, YUVPre_2, matrixOutputOffset[2]);
+          Int YUVLutB_2 = applyColourRemappingInfoLut1D(YUVMat_2, postLut[2], postLutInputPrecision);
+          YUVOut[COMPONENT_Cr][xc] = (YUVLutB_2 + scaleOut_round) >> scaleShiftOut_neg; // scaling output
+        }
+      }
+
+      YUVIn[COMPONENT_Y]  += iStride;
+      YUVOut[COMPONENT_Y] += iStride;
+      if( !(b420 && !(y&1)) )
+      {
+         YUVIn[COMPONENT_Cb]  += iCStride;
+         YUVIn[COMPONENT_Cr]  += iCStride;
+         YUVOut[COMPONENT_Cb] += iCStride;
+         YUVOut[COMPONENT_Cr] += iCStride;
+      }
+    }
+    //Write remapped picture in display order
+    m_pcPicYuvColourRemapped->dump( m_colourRemapSEIFileName, activeSPS.getBitDepths(), !firstPicture );
+  }
+}
+#endif
 
 #if ALIGNED_BUMPING
@@ -1238,42 +1520,8 @@
 
 #if Q0074_COLOUR_REMAPPING_SEI
-    if( m_colourRemapSEIEnabled )
-    {
-      const TComSPS *sps = pic->getSlice(0)->getSPS();
-      SEIMessages colourRemappingInfo = getSeisByType(pic->getSEIs(), SEI::COLOUR_REMAPPING_INFO );
-      const SEIColourRemappingInfo *seiColourRemappingInfo = ( colourRemappingInfo.size() > 0 ) ? (SEIColourRemappingInfo*) *(colourRemappingInfo.begin()) : NULL;
-
-      if (colourRemappingInfo.size() > 1)
-      {
-        printf ("Warning: Got multiple Colour Remapping Information SEI messages. Using first.");
-      }
-
-      if (seiColourRemappingInfo)
-      {
-        //printf ("\n\nColour Remapping is applied to POC : %d and LayerId : %d ",pic->getPOC(), pic->getLayerId());
-        xApplyColourRemapping( sps, *pic->getPicYuvRec(), seiColourRemappingInfo, pic->getLayerId() );
-      }
-      else  // using the last CRI SEI received
-      {
-        const SEIColourRemappingInfo *seiColourRemappingInfoCopy;
-        seiColourRemappingInfoCopy = seiColourRemappingInfoPrevious;
-        xApplyColourRemapping( sps, *pic->getPicYuvRec(), seiColourRemappingInfoCopy, pic->getLayerId() );
-      }
-
-      // save the last CRI SEI received
-      if( seiColourRemappingInfo != NULL){
-        if (seiColourRemappingInfoPrevious != NULL)
-        {
-          delete seiColourRemappingInfoPrevious;
-          seiColourRemappingInfoPrevious = NULL;
-        }
-        if (seiColourRemappingInfo->m_colourRemapPersistenceFlag)
-        {
-          seiColourRemappingInfoPrevious = new SEIColourRemappingInfo();
-          seiColourRemappingInfoPrevious->copyFrom(seiColourRemappingInfo);
-        }
-      }
-    }
-
+    if (!m_colourRemapSEIFileName.empty())
+    {
+      xOutputColourRemapPic(pic, pic->getSlice(0)->getSPS());
+    }
 #endif
   }
@@ -1795,173 +2043,3 @@
 #endif //ALIGNED_BUMPING
 
-#if Q0074_COLOUR_REMAPPING_SEI
-Void TAppDecTop::xInitColourRemappingLut( const BitDepths &bitDepths, std::vector<Int>(&preLut)[3], std::vector<Int>(&postLut)[3], const SEIColourRemappingInfo* const pCriSEI )
-{
-  for ( Int c=0 ; c<3 ; c++ )
-  {  
-    Int bitDepth = bitDepths.recon[toChannelType(ComponentID(c))];
-    preLut[c].resize(1 << bitDepth);
-    postLut[c].resize(1 << pCriSEI->m_colourRemapBitDepth);
-    
-    Int bitDepthDiff = pCriSEI->m_colourRemapBitDepth - bitDepth;
-    Int iShift1 = (bitDepthDiff>0) ? bitDepthDiff : 0; //bit scale from bitdepth to ColourRemapBitdepth (manage only case colourRemapBitDepth>= bitdepth)
-    if( bitDepthDiff<0 )
-      printf ("Warning: CRI SEI - colourRemapBitDepth (%d) <bitDepth (%d) - case not handled\n", pCriSEI->m_colourRemapBitDepth, bitDepth);
-    bitDepthDiff = pCriSEI->m_colourRemapBitDepth - pCriSEI->m_colourRemapInputBitDepth;
-    Int iShift2 = (bitDepthDiff>0) ? bitDepthDiff : 0; //bit scale from ColourRemapInputBitdepth to ColourRemapBitdepth (manage only case colourRemapBitDepth>= colourRemapInputBitDepth)
-    if( bitDepthDiff<0 )
-      printf ("Warning: CRI SEI - colourRemapBitDepth (%d) <colourRemapInputBitDepth (%d) - case not handled\n", pCriSEI->m_colourRemapBitDepth, pCriSEI->m_colourRemapInputBitDepth);
-
-    //Fill preLut
-    for ( Int k=0 ; k<(1<<bitDepth) ; k++ )
-    {
-      Int iSample = k << iShift1 ;
-      for ( Int iPivot=0 ; iPivot<=pCriSEI->m_preLutNumValMinus1[c] ; iPivot++ )
-      {
-        Int iCodedPrev  = pCriSEI->m_preLutCodedValue[c][iPivot]    << iShift2; //Coded in CRInputBitdepth
-        Int iCodedNext  = pCriSEI->m_preLutCodedValue[c][iPivot+1]  << iShift2; //Coded in CRInputBitdepth
-        Int iTargetPrev = pCriSEI->m_preLutTargetValue[c][iPivot];              //Coded in CRBitdepth
-        Int iTargetNext = pCriSEI->m_preLutTargetValue[c][iPivot+1];            //Coded in CRBitdepth
-        if ( iCodedPrev <= iSample && iSample <= iCodedNext )
-        {
-          Float fInterpol = (Float)( (iCodedNext - iSample)*iTargetPrev + (iSample - iCodedPrev)*iTargetNext ) * 1.f / (Float)(iCodedNext - iCodedPrev);
-          preLut[c][k]  = (Int)( 0.5f + fInterpol );
-          iPivot = pCriSEI->m_preLutNumValMinus1[c] + 1;
-        }
-      }
-    }
-    
-    //Fill postLut
-    for ( Int k=0 ; k<(1<<pCriSEI->m_colourRemapBitDepth) ; k++ )
-    {
-      Int iSample = k;
-      for ( Int iPivot=0 ; iPivot<=pCriSEI->m_postLutNumValMinus1[c] ; iPivot++ )
-      {
-        Int iCodedPrev  = pCriSEI->m_postLutCodedValue[c][iPivot];    //Coded in CRBitdepth
-        Int iCodedNext  = pCriSEI->m_postLutCodedValue[c][iPivot+1];  //Coded in CRBitdepth
-        Int iTargetPrev = pCriSEI->m_postLutTargetValue[c][iPivot];   //Coded in CRBitdepth
-        Int iTargetNext = pCriSEI->m_postLutTargetValue[c][iPivot+1]; //Coded in CRBitdepth
-        if ( iCodedPrev <= iSample && iSample <= iCodedNext )
-        {
-          Float fInterpol =  (Float)( (iCodedNext - iSample)*iTargetPrev + (iSample - iCodedPrev)*iTargetNext ) * 1.f / (Float)(iCodedNext - iCodedPrev) ;
-          postLut[c][k]  = (Int)( 0.5f + fInterpol );
-          iPivot = pCriSEI->m_postLutNumValMinus1[c] + 1;
-        }
-      }
-    }
-  }
-}
-
-Void TAppDecTop::xApplyColourRemapping( const TComSPS *sps, TComPicYuv& pic, const SEIColourRemappingInfo* pCriSEI, UInt layerId )
-{
-  const BitDepths& bitDpeths = sps->getBitDepths();
-
-  if( !storeCriSEI.size() )
-  {
-#if SVC_EXTENSION
-    storeCriSEI.resize(MAX_LAYERS);
-#else
-    storeCriSEI.resize(1);
-#endif
-  }
-
-  if ( pCriSEI ) //if a CRI SEI has just been retrieved, keep it in memory (persistence management)
-  {
-    storeCriSEI[layerId] = *pCriSEI;
-  }
-
-  if( !storeCriSEI[layerId].m_colourRemapCancelFlag && pCriSEI) 
-  {
-    Int iHeight  = pic.getHeight(COMPONENT_Y);
-    Int iWidth   = pic.getWidth(COMPONENT_Y);
-    Int iStride  = pic.getStride(COMPONENT_Y);
-    Int iCStride = pic.getStride(COMPONENT_Cb);
-
-    Pel *YUVIn[3], *YUVOut[3];
-    YUVIn[0] = pic.getAddr(COMPONENT_Y);
-    YUVIn[1] = pic.getAddr(COMPONENT_Cb);
-    YUVIn[2] = pic.getAddr(COMPONENT_Cr);
-    
-    TComPicYuv picColourRemapped;
-
-#if SVC_EXTENSION
-#if AUXILIARY_PICTURES
-    picColourRemapped.create( pic.getWidth(COMPONENT_Y), pic.getHeight(COMPONENT_Y), pic.getChromaFormat(), sps->getMaxCUWidth(), sps->getMaxCUHeight(), sps->getMaxTotalCUDepth(), true, NULL );
-#else
-    picColourRemapped.create( pic.getWidth(), pic.getHeight(), sps->getMaxCUWidth(), sps->getMaxCUHeight(), sps->getMaxTotalCUDepth(), true, NULL );
-#endif
-#else
-    picColourRemapped.create( pic.getWidth(COMPONENT_Y), pic.getHeight(COMPONENT_Y), pic.getChromaFormat(), sps->getMaxCUWidth(), sps->getMaxCUHeight(), sps->getMaxTotalCUDepth(), true );
-#endif 
-    YUVOut[0] = picColourRemapped.getAddr(COMPONENT_Y);
-    YUVOut[1] = picColourRemapped.getAddr(COMPONENT_Cb);
-    YUVOut[2] = picColourRemapped.getAddr(COMPONENT_Cr);
-
-    std::vector<Int> preLut[3];
-    std::vector<Int> postLut[3];
-    xInitColourRemappingLut( bitDpeths, preLut, postLut, &storeCriSEI[layerId] );
-    
-    Int roundingOffset = (storeCriSEI[layerId].m_log2MatrixDenom==0) ? 0 : (1 << (storeCriSEI[layerId].m_log2MatrixDenom - 1));
-
-    for( Int y = 0; y < iHeight ; y++ )
-    {
-      for( Int x = 0; x < iWidth ; x++ )
-      {
-        Int YUVPre[3], YUVMat[3];
-        YUVPre[0] = preLut[0][ YUVIn[0][x]   ];
-        YUVPre[1] = preLut[1][ YUVIn[1][x>>1] ];
-        YUVPre[2] = preLut[2][ YUVIn[2][x>>1] ];
-
-        YUVMat[0] = ( storeCriSEI[layerId].m_colourRemapCoeffs[0][0]*YUVPre[0]
-                    + storeCriSEI[layerId].m_colourRemapCoeffs[0][1]*YUVPre[1] 
-                    + storeCriSEI[layerId].m_colourRemapCoeffs[0][2]*YUVPre[2] 
-                    + roundingOffset ) >> ( storeCriSEI[layerId].m_log2MatrixDenom );
-        YUVMat[0] = Clip3( 0, (1<<storeCriSEI[layerId].m_colourRemapBitDepth)-1, YUVMat[0] );
-        YUVOut[0][x] = postLut[0][ YUVMat[0] ];
-
-        if( (y&1) && (x&1) )
-        {
-          for(Int c=1 ; c<3 ; c++)
-          {
-            YUVMat[c] = ( storeCriSEI[layerId].m_colourRemapCoeffs[c][0]*YUVPre[0] 
-                        + storeCriSEI[layerId].m_colourRemapCoeffs[c][1]*YUVPre[1] 
-                        + storeCriSEI[layerId].m_colourRemapCoeffs[c][2]*YUVPre[2] 
-                        + roundingOffset ) >> ( storeCriSEI[layerId].m_log2MatrixDenom );
-            YUVMat[c] = Clip3( 0, (1<<storeCriSEI[layerId].m_colourRemapBitDepth)-1, YUVMat[c] );
-            YUVOut[c][x>>1] = postLut[c][ YUVMat[c] ];   
-          }
-        }
-      }
-      YUVIn[0]  += iStride;
-      YUVOut[0] += iStride;
-      if( y&1 )
-      {
-        YUVIn[1]  += iCStride;
-        YUVIn[2]  += iCStride;
-        YUVOut[1] += iCStride;
-        YUVOut[2] += iCStride;
-      }
-    }
-
-    //Write remapped picture in decoding order
-    TChar  cTemp[255];
-    sprintf(cTemp, "seiColourRemappedPic_L%d_%dx%d_%dbits.yuv", layerId, iWidth, iHeight, storeCriSEI[layerId].m_colourRemapBitDepth );
-    picColourRemapped.dump( cTemp, true, storeCriSEI[layerId].m_colourRemapBitDepth );
-
-    picColourRemapped.destroy();
-
-    storeCriSEI[layerId].m_colourRemapCancelFlag = !storeCriSEI[layerId].m_colourRemapPersistenceFlag; //Handling persistence
-  }
-  else
-  {
-    //Write no remapped picture in decoding order
-    if (storeCriSEI[layerId].m_colourRemapBitDepth == 8 || storeCriSEI[layerId].m_colourRemapBitDepth == 10)
-    {
-      TChar  cTemp[255];
-      sprintf(cTemp, "seiColourRemappedPic_L%d_%dx%d_%dbits.yuv", layerId, pic.getWidth(COMPONENT_Y), pic.getHeight(COMPONENT_Y), storeCriSEI[layerId].m_colourRemapBitDepth );
-      pic.dump( cTemp, true, storeCriSEI[layerId].m_colourRemapBitDepth );
-    }
-  }
-}
-#endif
 //! \}
